package calc;

import java.io.InputStream;

class Parser extends Scanner {
    
    public Parser(InputStream in) {
        super(in);
        nextToken();
    }

    public void expression() {
        term();
        while (token == PLUS || token == MINUS ) {
            nextToken();
            term();
        }
    }

    public void term() {
        factor();
        while (token == MUL || token == DIV) {
            nextToken();
            factor();
        }
    }
    
    public void factor()  {
    switch(token) {
    case LITERAL: 
        nextToken(); 
        break;
    case LPAREN: 
        nextToken(); 
        expression();
        if (token == RPAREN) {
            nextToken();
        } else {
            error("')' expected");
        }
        break;
    default:
        error("illegal start of expression");
    }
    }
}
