package calc;

import java.io.InputStream;
import java.io.IOException;
import java.io.FileInputStream;

class Scanner implements Tokens {

    protected int pos = 0;

    public static void error(String msg) {
        throw new RuntimeException(msg);
    }

    protected InputStream in;
    public Scanner(InputStream in) {
        this.in = in;
    }

    private static final int EOLChar = '\n';
    
    protected int    token = BAD;
    protected String chars = "";

    char   ch = ' ';
    
    private void nextChar() {
        try {
            ch = (char)in.read();
            pos = pos + 1;
        } catch(java.io.IOException e) {
            error(e.getMessage());
        }
    }
    
    public String representation() {
        return representation(this.token, this.chars);
    }
    public static String representation(int token) {
        return representation(token, "");
    }
    public static String representation(int token, String chars) {
        switch(token) {
        case LITERAL: return "LITERAL(" + chars + ") ";
        case PLUS:    return "+";
        case MINUS:   return "-";
        case MUL:     return "*";
        case DIV:     return "/";
        case LPAREN:  return "(";
        case RPAREN:  return ")";
        case BAD:     return "<BAD>";
        case EOL:     return "<EOL>";
        default: error("not a token: "+token+")");
        }
        return null; // should not happen
    }

    public void close() { 
        try { 
            in.close(); 
        } catch(IOException e) {
            error(e.getMessage());
        }
    }
    public void nextToken() {
        while (ch!= EOLChar && ch <= ' ') 
            nextChar();
        if (Character.isDigit(ch)) {
            StringBuffer buf = new StringBuffer();
            buf.append(ch); 
            nextChar();
            while (Character.isDigit(ch)) {
                buf.append(ch); 
                nextChar();
            }
            token = LITERAL;
            chars = buf.toString();
        } else switch(ch) {
      case '(': token = LPAREN; nextChar(); break;
      case ')': token = RPAREN; nextChar(); break;
      case '+': token = PLUS; nextChar(); break;
      case '*': token = MUL; nextChar(); break;
      case '-': token = MINUS; nextChar(); break;
        case '/': token = DIV; nextChar(); break;
      case EOLChar:  token = EOL;  break;
      default: token = BAD; nextChar();
    }
        // System.out.println(representation()); // DEBUG
  }
}
