package calc;

import java.io.InputStream;

class Parser(in:InputStream) extends Scanner(in) {

  import Tokens._;

  // initialization
  nextToken();

  def expression: Int = {
    var v: int = term;
    while(token == PLUS || token == MINUS ) {
      val operator: int = token;
      nextToken();
      val v2: int = term;
      if(operator == PLUS) 
        v = v + v2
      else
        v = v - v2;
    }
    return v
  }

  def term: Int = {
    var v: int = factor;
    while (token == MUL || token == DIV) {
      val operator: int = token;
      nextToken();
      val v2 = factor;
      if(operator == MUL) 
        v = v * v2
      else
        v = v / v2;
    }
    return v
  }

  def factor: Int = {
    var v: int = 0;
    token match {
      case LITERAL => 
        v = Integer.parseInt(chars);
        nextToken();
      case LPAREN => 
        nextToken();
        v = expression;
        if(token == RPAREN)
          nextToken();
        else
          error("')' expected");
      case _ =>
        error("illegal start of expression");
    }
    return v;
  }
}
