package calc;

import java.io.InputStream;

class Parser(in:InputStream) extends Scanner(in) {

  import Tokens._;

  // initialization
  nextToken();

  def expression: Expr = {
    var t: Expr = term;
    while(token == PLUS || token == MINUS ) {
      val startpos: int = pos;
      val operator: int = token;
      nextToken();
      val t2 = term;
      t = BinOp(startpos, operator, t, t2);
    }
    return t;
  }

  def term: Expr = {
    var t: Expr = factor;
    while (token == MUL || token == DIV) {
      val startpos: int = pos;
      val operator: int = token;
      nextToken();
      val t2 = factor;
      t = BinOp(startpos, operator, t, t2);
    }
    return t;
  }

  def factor: Expr = {
    var t: Expr = _;
    token match {
      case LITERAL => 
        t = IntLit(pos, Integer.parseInt(chars));
        nextToken();
      case LPAREN => 
        nextToken();
        t = expression;
        if(token == RPAREN)
          nextToken();
        else
          error("')' expected");
      case _ =>
        Console.println(representation());
        error("illegal start of expression");
    }
    return t;
  }
}
