//
//
// Structure des classes
//
//

// en Java, c'est simple de completer les definitions de bases
/*
abstract class Expr {
  int pos;
  static class IntLit extends Expr {
    int value;
    ...
  }
  static class BinOp extends Expr {
    Expr left;
    Expr right;
    ...
  }
}
*/
// il suffit d' ajouter les constructeurs
package calc;

public abstract class Expr {
  /** position pour signaler les erreurs, presente dans tous les noeuds. */
  int pos;

  /** sous-classe pour representer les nombres */
  static class IntLit extends Expr {
    int value;
    IntLit(int pos, int value) {
      this.pos = pos;
      this.value = value;
    }
  }

  /** sous-classe pour representer les operations */
  static class BinOp extends Expr {
    int operator;
    Expr left, right;

    BinOp(int pos, int operator, Expr left, Expr right) {
      this.pos = pos;
      this.operator = operator;
      this.left = left;
      this.right = right;
    }
  }
}


//
//
// acceder aux arbres, en Java:
/*
if(tree instanceOf IntLit) {
  int value = ((IntLit)tree).value;
  ...
} else if(tree instanceOf BinOp) {
  BinOp bop = ((BinOp)tree);
  Expr left = binop.left;
  Expr left = binop.right;
  ...
}

*/
