// in Java
package calc;

import java.io.InputStream;
import calc.Expr.*; // importer sous-class d'arbre

class Parser extends Scanner {

  public Parser(InputStream in) {
    super(in);
    nextToken();
  }

  public Expr expression() {
    Expr t = term();
    while(token == PLUS || token == MINUS ) {
      int startpos = pos;
      int operator = token;
      nextToken();
      Expr t2 = term();
      t = new BinOp(startpos, operator, t, t2);
    }
    return t;
  }

  public Expr term() {
    Expr t = factor();
    while (token == MUL || token == DIV) {
      int startpos = pos;
      int operator = token;
      nextToken();
      Expr t2 = factor();
      t = new BinOp(startpos, operator, t, t2);
    }
    return t;
  }

  public Expr factor() {
    Expr t = null;
    if(token == LITERAL) {
      t = new IntLit(pos, Integer.parseInt(chars));
      nextToken();
    } else if (token == LPAREN) {
      nextToken();
      t = expression();
      if(token == RPAREN)
        nextToken();
      else
        error("')' expected");
    } else {
      error("illegal start of expression");
    }
    return t;
  }
}
