package calc;

object Main {
  import Tokens._;

  def eval(e: Expr): int = {
    e match {
      case IntLit(_, value)   => 
        return value;
      case BinOp(_, op, left, right) => 
        val l: int = eval(left);
        val r: int = eval(right);
        op match {
          case PLUS  => return l+r;
          case MINUS => return l-r;
          case MUL   => return l*r;
          case DIV   => return l/r;
          case _             => error("malformed op");
        }
    }
  }

  def toString(e: Expr): String = {
    e match {
      case IntLit(_, value)   => 
        return value.toString();
      case BinOp(_, op, left, right) => 
        "("+toString(left)+Scanner.representation(op)+toString(right)+")";
    }
  }

    def main(args: Array[String]): Unit = {
        Console.print("> ");
        val t: Expr = new Parser(System.in).expression;
        if(t != null) {
          Console.println(toString(t)+" evaluates to "+eval(t));
        }
    }
}
